unit Unit1;

interface

uses
  SysUtils, Classes, HTTPApp, HTTPProd, DB, DBClient, DBWeb, DSProd,
  DBXpress, FMTBcd, DBXpressWeb, SqlExpr;

type
  TWebModule1 = class(TWebModule)
    ppTeste1: TPageProducer;
    dstpTeste2: TDataSetTableProducer;
    cdsTeste2: TClientDataSet;
    dsppTeste3: TDataSetPageProducer;
    cdsTeste3: TClientDataSet;
    Conexao: TSQLConnection;
    qryCustomer: TSQLQuery;
    qryCustomerCUST_NO: TIntegerField;
    qryCustomerCUSTOMER: TStringField;
    qryCustomerCONTACT_FIRST: TStringField;
    qryCustomerCONTACT_LAST: TStringField;
    qryCustomerPHONE_NO: TStringField;
    qryCustomerADDRESS_LINE1: TStringField;
    qryCustomerADDRESS_LINE2: TStringField;
    qryCustomerCITY: TStringField;
    qryCustomerSTATE_PROVINCE: TStringField;
    qryCustomerCOUNTRY: TStringField;
    qryCustomerPOSTAL_CODE: TStringField;
    qryCustomerON_HOLD: TStringField;
    SqlQryTPCustomer: TSQLQueryTableProducer;
    qryClientes: TSQLQuery;
    qryClientesCUST_NO: TIntegerField;
    qryClientesCUSTOMER: TStringField;
    qryClientesPHONE_NO: TStringField;
    qryClientesCITY: TStringField;
    dstpQryClientes: TDataSetTableProducer;
    qryPedidos: TSQLQuery;
    dstpQryPedidos: TDataSetTableProducer;
    qryPedidosPO_NUMBER: TStringField;
    qryPedidosORDER_DATE: TSQLTimeStampField;
    qryPedidosORDER_STATUS: TStringField;
    qryPedidosPAID: TStringField;
    qryPedido: TSQLQuery;
    dsppPedido: TDataSetPageProducer;
    qryPedidoPO_NUMBER: TStringField;
    qryPedidoCUST_NO: TIntegerField;
    qryPedidoFULL_NAME: TStringField;
    qryPedidoORDER_STATUS: TStringField;
    qryPedidoORDER_DATE: TSQLTimeStampField;
    qryPedidoSHIP_DATE: TSQLTimeStampField;
    qryPedidoDATE_NEEDED: TSQLTimeStampField;
    qryPedidoPAID: TStringField;
    qryPedidoQTY_ORDERED: TIntegerField;
    qryPedidoTOTAL_VALUE: TBCDField;
    qryPedidoDISCOUNT: TFloatField;
    qryPedidoITEM_TYPE: TStringField;
    qryPedidoAGED: TFloatField;
    procedure WebModule1waPadraoAction(Sender: TObject; Request: TWebRequest;
      Response: TWebResponse; var Handled: Boolean);
    procedure ppTeste1HTMLTag(Sender: TObject; Tag: TTag;
      const TagString: String; TagParams: TStrings;
      var ReplaceText: String);
    procedure WebModule1waTeste3Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure WebModule1waListarClientesAction(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure dstpQryClientesFormatCell(Sender: TObject; CellRow,
      CellColumn: Integer; var BgColor: THTMLBgColor;
      var Align: THTMLAlign; var VAlign: THTMLVAlign; var CustomAttrs,
      CellData: String);
    procedure WebModule1waListarPedidosAction(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure qryPedidosPAIDGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
    procedure dstpQryPedidosFormatCell(Sender: TObject; CellRow,
      CellColumn: Integer; var BgColor: THTMLBgColor;
      var Align: THTMLAlign; var VAlign: THTMLVAlign; var CustomAttrs,
      CellData: String);
    procedure WebModule1waDetalhesPedidoAction(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WebModule1: TWebModule1;

implementation

{$R *.dfm}

procedure TWebModule1.WebModule1waPadraoAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  i: Integer;
begin
  //monta o cabealho da pgina
  Response.Content := '<h3 style=color:#0000FF>Meu primeiro ' + 
    'aplicativo webbroker</h3>';

  //monta a lista completa das propriedades que uma Requisio
  //pode oferecer, com seus respectivos valores
  Response.Content := Response.Content +
    '<p><font color=red><b>Propriedades da requisio:</b></font><br>' +
    '<b>Method:</b> ' + Request.Method + '<br>' +
    '<b>ProtocolVersion:</b> ' + Request.ProtocolVersion + '<br>' +
    '<b>URL:</b> ' + Request.URL + '<br>' +
    '<b>Query:</b> ' + Request.Query + '<br>' +
    '<b>PathInfo:</b> ' + Request.PathInfo + '<br>' +
    '<b>PathTranslated:</b> ' + Request.PathTranslated + '<br>' +
    '<b>Authorization:</b> ' + Request.Authorization + '<br>' +
    '<b>CacheControl:</b> ' + Request.CacheControl + '<br>'+
    '<b>Cookie:</b> ' + Request.Cookie + '<br>' +
    '<b>Accept:</b> ' + Request.Accept + '<br>' +
    '<b>From:</b> ' + Request.From + '<br>' +
    '<b>Host:</b> ' + Request.Host + '<br>' +
    '<b>Referer:</b> ' + Request.Referer + '<br>' +
    '<b>UserAgent:</b> ' + Request.UserAgent + '<br>' +
    '<b>ContentEncoding:</b> ' + Request.ContentEncoding + '<br>' +
    '<b>ContentType:</b> ' + Request.ContentType + '<br>' +
    '<b>ContentVersion:</b> ' + Request.ContentVersion + '<br>' +
    '<b>Content:</b> ' + Request.Content + '<br>' +
    '<b>Connection:</b> ' + Request.Connection + '<br>' +
    '<b>DerivedFrom:</b> ' + Request.DerivedFrom + '<br>' +
    '<b>Title:</b> ' + Request.Title + '<br>' +
    '<b>RemoteAddr:</b> ' + Request.RemoteAddr + '<br>' +
    '<b>RemoteHost:</b> ' + Request.RemoteHost + '<br>' +
    '<b>ScriptName:</b> ' + Request.ScriptName + '<br>' +
    '<b>InternalPathInfo:</b> ' + Request.InternalPathInfo + '<br>' +
    '<b>InternalScriptName:</b> ' + Request.InternalScriptName + '</p>';

  //exibe a lista de aes disponveis na instancia corrente do webmodule
  Response.Content := Response.Content +
    '<p><font color=green><b>Lista de Aes disponveis:</b></font><br>';
  for i := 0 to Self.Actions.Count-1 do
    Response.Content := Response.Content +
      IntToStr(i) + ': ' + Self.Actions[i].Name + ' - ' + 
      Self.Actions[i].PathInfo + '<br>';
  Response.Content := Response.Content + '</p>';
end;

procedure TWebModule1.ppTeste1HTMLTag(Sender: TObject; Tag: TTag;
  const TagString: String; TagParams: TStrings; var ReplaceText: String);
begin
  if TagString = 'hora' then
    ReplaceText := TimeToStr(Time) + ' hrs';
end;

procedure TWebModule1.WebModule1waTeste3Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  ID: String; //armazenar o cdigo passado por parmetro
begin
  //verifica se veio o parmetro ID na URL
  if Request.QueryFields.Values['id'] <> '' then
  begin
    //se veio, recupera o seu valor
    ID := Request.QueryFields.Values['id'];
    //filtra o ClientDataSet para que encontre o cliente
    //especificado. Neste ponto, tambm poderamos executar
    //uma instruo SQL no banco de dados, por exemplo.
    cdsTeste3.Filtered := False;
    cdsTeste3.Filter   := 'CustNo = ' + ID;
    cdsTeste3.Filtered := True;
    //se no encontrou nada, alerta o usurio
    if cdsTeste3.IsEmpty then
      response.Content := '<b>Cliente no localizado!</b><br><br>' +
                          'Voc informou: ' + ID
    else
      //e se encontrou, pega o retorno do prprio dsppTeste3
      response.Content := dsppTeste3.Content;
  end
  else
    //se no veio parmetro, alerta o usurio
    Response.Content := '<b>Cliente no especificado!</b>'
    //obs: este alerta poderia tambm vir de um arquivo ou
    //PageProducer padro para erros, e seria algo como:
    //Response.Content := ppClienteNaoEspecificado.Content;
end;

procedure TWebModule1.WebModule1waListarClientesAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
begin
  //apenas para visualizar a animao na requisio Ajax
  Sleep(1000);

  try
    //preenche o parmetro da sql com o parmetro vindo na requisio 
    qryClientes.Params[0].AsString :=
      AnsiUpperCase(Request.QueryFields.Values['nome']) + '%';
    //abre a query
    qryClientes.Open;
    //se no encontrou nada, mostra mensagem especfica
    if qryClientes.IsEmpty then
      Response.Content := '<b>Nenhum cliente localizado!</b>'
    else
      //caso contrrio, pega o retorno gerado pelo componente DataSetTabelProducer
      Response.Content := dstpQryClientes.Content;
    //fecha a query
    qryClientes.Close;
  except
    on E: Exception do
      Response.Content := '<font color=red>O seguinte erro ocorreu: ' +
        E.Message;
  end;
end;

procedure TWebModule1.dstpQryClientesFormatCell(Sender: TObject; CellRow,
  CellColumn: Integer; var BgColor: THTMLBgColor; var Align: THTMLAlign;
  var VAlign: THTMLVAlign; var CustomAttrs, CellData: String);
var
  DivID: String;
begin
  //se est processando a primeira linha, ento, ignora o cdigo
  if CellRow = 0 then
    exit;

  //calcula o id dos objetos div, que ser a palavra 'div' + o id do Customer
  DivID := 'div' + qryClientesCUST_NO.AsString;

  //se est na primeira coluna, monta o link com o javascript para carregar
  //os pedidos dentro do div daquele registro
  if CellColumn = 0 then
    CellData := '<a href="javascript:AbreUrl(''Project1.exe/ListarPedidos?cust_no=' +
      qryClientesCUST_NO.AsString + ''',''' + DivID + ''', ''Pesquisando Pedidos...'');' +
      ' ExibeDiv(''' + DivID + ''', true)">' + CellData + '</a>'

  //se for a ltima coluna, abre uma nova linha logo abaixo desta, com o div
  //corresponde quele registro, para ser utilizado nas chamadas via ajax
  else if CellColumn = dstpQryClientes.Columns.Count-1 then
  begin
    CellData := CellData + '</td></tr><tr><td colspan=' +
      IntToStr(dstpQryClientes.Columns.Count) + '>' +
      '<div style="display:none;" id=' + DivID + '></div>';
  end;
end;

procedure TWebModule1.WebModule1waListarPedidosAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
begin
  //apenas para visualizar a animao na requisio Ajax
  Sleep(1000);

  try
    //preenche o parmetro da sql com o parmetro vindo na requisio
    qryPedidos.Params[0].AsString := Request.QueryFields.Values['cust_no'];
    //abre a query
    qryPedidos.Open;
    //se no encontrou nada, mostra mensagem especfica
    if qryPedidos.IsEmpty then
      Response.Content := '<b>Nenhum pedido cadastrado para este cliente!</b>'
    else
      //caso contrrio, pega o retorno gerado pelo componente DataSetTabelProducer
      Response.Content := dstpQryPedidos.Content;
    //fecha a query
    qryPedidos.Close;
  except
    on E: Exception do
      Response.Content := '<font color=red>O seguinte erro ocorreu: ' +
        E.Message;
  end;
end;

procedure TWebModule1.qryPedidosPAIDGetText(Sender: TField;
  var Text: String; DisplayText: Boolean);
begin
  if AnsiLowerCase(Sender.AsString) = 'y' then
    Text := 'Sim'
  else
    Text := 'Nao';
end;

procedure TWebModule1.dstpQryPedidosFormatCell(Sender: TObject; CellRow,
  CellColumn: Integer; var BgColor: THTMLBgColor; var Align: THTMLAlign;
  var VAlign: THTMLVAlign; var CustomAttrs, CellData: String);
var
  DivID: String;
begin
  //se est processando a primeira linha, ento, ignora o cdigo
  if CellRow = 0 then
    exit;

  //calcula o id dos objetos div, que ser a palavra
  //'divPed' + o id do Pedido
  DivID := 'divPed' + qryPedidosPO_NUMBER.AsString;

  //se est na primeira coluna, monta o link com o javascript
  //para carregar os detalhes do pedido dentro do div correspondente
  if CellColumn = 0 then
    CellData := '<a href="javascript:AbreUrl(''Project1.exe/DetalhesPedido?po_number=' +
      qryPedidosPO_NUMBER.AsString + ''',''' + DivID + ''', ''Carregando Detalhes do Pedido...'');' +
      ' ExibeDiv(''' + DivID + ''', true)">' + CellData + '</a>'

  //se for a ltima coluna, abre uma nova linha logo abaixo desta, com o div
  //corresponde quele registro, para ser utilizado nas chamadas via ajax
  else if CellColumn = dstpQryPedidos.Columns.Count-1 then
  begin
    CellData := CellData + '</td></tr><tr><td colspan=' +
      IntToStr(dstpQryPedidos.Columns.Count) + '>' +
      '<div style="display:none; background-color:#FFFFFF;"' +
      ' id=' + DivID + '></div>';
  end;
end;

procedure TWebModule1.WebModule1waDetalhesPedidoAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
begin
  //apenas para visualizar a animao na requisio Ajax
  Sleep(1000);

  try
    //preenche o parmetro da sql com o parmetro vindo na requisio
    qryPedido.Params[0].AsString := Request.QueryFields.Values['po_number'];
    //abre a query
    qryPedido.Open;
    //se no encontrou nada, mostra mensagem especfica
    if qryPedido.IsEmpty then
      Response.Content := '<b>Pedido no localizado!</b>'
    else
      //caso contrrio, pega o retorno gerado pelo componente DataSetTabelProducer
      Response.Content := dsppPedido.Content;
    //fecha a query
    qryPedido.Close;
  except
    on E: Exception do
      Response.Content := '<font color=red>O seguinte erro ocorreu: ' +
        E.Message;
  end;
end;

end.
