unit untConLog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, Grids, DBGrids, ComCtrls, StdCtrls, DBClient;

type
  TfrmConLog = class(TForm)
    dbgGrid: TDBGrid;
    dsrDS: TDataSource;
    btnSearch: TButton;
    edtData: TDateTimePicker;
    procedure btnSearchClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmConLog: TfrmConLog;

implementation

uses untDM;

{$R *.dfm}

procedure TfrmConLog.btnSearchClick(Sender: TObject);
begin
  //passagem de parmetro para consulta de Logs -> dar uses em DBClient
  TClientDataSet(dsrDS.DataSet).Close;
  TClientDataSet(dsrDS.DataSet).Params[0].AsDate:= edtData.Date;
  TClientDataSet(dsrDS.DataSet).Open;
end;

procedure TfrmConLog.FormShow(Sender: TObject);
begin
  //inicia com a data atual
  edtData.Date:= Now;
end;

procedure TfrmConLog.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //garante que ao fechar a tela, o DataSet seja fechado
  dsrDS.DataSet.Close;
end;

end.
