unit untDM;

interface

uses
  SysUtils, Classes, DBXpress, FMTBcd, DBClient, Provider, DB, SqlExpr;

type
  TDM = class(TDataModule)
    conConexao: TSQLConnection;
    sdtCountry: TSQLDataSet;
    dspCountry: TDataSetProvider;
    cdsCountry: TClientDataSet;
    sdtCountryCOUNTRY: TStringField;
    sdtCountryCURRENCY: TStringField;
    sdtLog: TSQLDataSet;
    dspLog: TDataSetProvider;
    cdsLog: TClientDataSet;
    sspLog: TSQLStoredProc;
    cdsCountryCOUNTRY: TStringField;
    cdsCountryCURRENCY: TStringField;
    procedure cdsCountryAfterPost(DataSet: TDataSet);
    procedure cdsCountryAfterDelete(DataSet: TDataSet);
    procedure dspCountryBeforeUpdateRecord(Sender: TObject;
      SourceDS: TDataSet; DeltaDS: TCustomClientDataSet;
      UpdateKind: TUpdateKind; var Applied: Boolean);
  private
    FUsuario: String;
    procedure SetUsuario(const Value: String);
    { Private declarations }
  public
    { Public declarations }
    property Usuario: String read FUsuario write SetUsuario;
  end;

var
  DM: TDM;

implementation

{$R *.dfm}

procedure TDM.cdsCountryAfterPost(DataSet: TDataSet);
begin
  cdsCountry.ApplyUpdates(0);
end;

procedure TDM.cdsCountryAfterDelete(DataSet: TDataSet);
begin
  cdsCountry.ApplyUpdates(0);
end;

procedure TDM.dspCountryBeforeUpdateRecord(Sender: TObject;
  SourceDS: TDataSet; DeltaDS: TCustomClientDataSet;
  UpdateKind: TUpdateKind; var Applied: Boolean);
begin
  //Passa valor para o parmetro da procedure e a executa
  sspLog.Close;
  sspLog.Params[0].AsString:= FUsuario;
  sspLog.ExecProc;
end;

procedure TDM.SetUsuario(const Value: String);
begin
  FUsuario := Value;
end;

end.
